# objets tangibles - emitter

> Application basée sur Node.js et Express 4 qui envoie des datagrammes TUIO en fonction des touch-events récupérés sur une page web

## Description

Le projet fourni est composé de 2 parties:
* un backend
* un frontend

Le backend est une application Node.js basée sur Express; il officie comme émetteur de données TUIO qui sont récupérées à chaque touch-event.

Le frontend est une page web, servie par le backend, qui envoie les touch-events au backend via requête HTTP.

Chaque partie est contenue dans le dossier correspondant.


## Pré-requis

* Installer Node.js (v16 ou v17)
* Installer les dépendances:

```sh
cd receiver
npm install
```


## Lancer le serveur

Dans le dossier du projet, lancer la commande suivante:

```sh
node ./backend/server.js
```

* La page du frontend sera accessible à l'adresse http://localhost:5001
* Le serveur envoie les messages TUIO sur le port UDP 3333.


## Gestion de la "section" d'identifiants de points

Utiliser le paramètre d'URL `section` pour déterminer le modulo qui sera appliqué aux identifiants de points, par exemple: http://localhost:5001?section=100

Valeurs possibles: 100, 200, 300


## Gestion du mode "debug" sur le frontend

Ajouter le paramètre "debug" avec comme valeur 1 à l'URL: http://localhost:5001?debug=1 ou http://localhost:5001?section=100&debug=1

Le mode debug affiche les messages de debuggage dans la console du navigateur.

